function [l,u,pred_l,pred_u ] = GPUCB_reach_T( model, time, range,  weight, kernel, options, GPUCBoptions)
%GPUCB_diff_T 

     pn = [model.var_names(logical(model.explore_vars)), model.par_names(logical(model.explore_pars))];
     domain = GPUCB_getDomain(ones(length(pn),1),pn);
     domain.standardise=0;
     domain.trueRange = range;
     
    [~,pred_u,~,u] = GPUCB_Optimise(@funcUB,domain,kernel,GPUCBoptions);
    [~,pred_l,~,l] = GPUCB_Optimise(@funcLB,domain,kernel,GPUCBoptions);
    l = -l;
    pred_l = -pred_l;


    function [y,noise] = funcUB(point)
        noise = options.noise_level;
        y = simulateModelAtTP( model, time, point, weight, options );
    end


    function [y,noise] = funcLB(point)
        noise = options.noise_level;
        y = simulateModelAtTP( model, time, point, weight, options );
        y = -y;
    end

end
