function [V,l,u] = GPreachTpca(input,obs,obs1,options,kernel,range,H_base,aux)
%obs must be the size of the number of variables


dim = size(range,1);
gridPoints = options.gridPointsPerCoordinate*ones(1,dim);
grid = regularGrid(gridPoints,range);

basisFunc = aux.basisFunc;
dBasisFunc = aux.dBasisFunc;

% basisFunc =  @(X)[1, X(1), X(2), X(1)^2, X(1)*X(2), X(2)^2];
% %basisFunc =  @(X)[1, X(1), X(2)];
% 
% dBasisFunc = @(X)[0, 1, 0, 2*X(1), X(2),      0;
%                   0, 0 ,1,      0, X(1), 2*X(2) ];
% 
              
              
              

U = obs';
C = princomp(U);
n = size(obs,1);
Hdim = size(H_base,1) + n;
H0 = [H_base;
      C'];
lower = ones(Hdim,1);
upper = ones(Hdim,1);


for i=1:Hdim
    O = 0;
    O1 = 0;
    lb = 0;
    ub = 0;
    for j=1:n
        O = O + H0(i,j)*obs(j,:);
        O1 = O1 +  H0(i,j)*obs1(j,:,:);
        if H0(i,j) > 0
           lb = lb + H0(i,j)*aux.lower_bound(j); 
           ub = ub + H0(i,j)*aux.upper_bound(j); 
        elseif H0(i,j) < 0
            lb = lb + H0(i,j)*aux.upper_bound(j); 
            ub = ub + H0(i,j)*aux.lower_bound(j); 
        end
    end
    if length(aux.upper_bound) >= i
       ub =  aux.upper_bound(i);
    end
    if length(aux.lower_bound) >= i
       lb =  aux.lower_bound(i);
    end
    [l, u] = GPreach(input,O,O1,kernel,grid,options,basisFunc,dBasisFunc);
    lower(i) = max(l,lb);
    upper(i) = min(u,ub);
end


H = [ H0;
     -H0];
K=[upper;-lower];

% disp('Done');
% disp(H0);
% disp([lower,upper]);

P = polytope(H,K);
V = extreme(P);
ind = convhull(V(:,1),V(:,2));
V = V(ind,:);
l = lower(1:n);
u = upper(1:n);

end
