clear all;
N0 = 100;
modelSym = SIRsym(N0);
model = getModel(modelSym);
options = getOptions();



points = 5;
p = 2; %p=2 for SIRsym, p=1 for the other
input = linspace(model.par_range(p,1),model.par_range(p,2),points)';


kernel = getKernel(2);
%optimised ls for xS
%kernel.lengthscale(1) = 6.3003e-04;
%kernel.lengthscale(2) = 18.9637;
 kernel.lengthscale(1) = 0.002;
 kernel.lengthscale(2) = 20;


time = [0,10,20,30,40,50,60,70,80,90,100,150,300];
tl = length(time)-1;
tp = 30;

for j=1:tl
    kernel.lengthscale(2) = (time(j+1)-time(j))/5;
    VV{j} = SIRreachF(N0,model,options,kernel,input,p,time(j),time(j+1),tp);
end

options.final_time = 300;
options.time_points = 200;
[ tt,obs,obs1 ] = simulateModel( model, input, options );
[~,U,~] = mergeTraj(input,tt,obs,obs1);

%plot reachable polytope!
figure;
for j=1:tl
    V = VV{j}
    fill(V(:,1),V(:,2),'r');
    hold on;
end
 
plot(U(1,:),U(2,:),'x');

