function V = SIRreachF(N0,model,options,kernel,input,p,t0,t1,tp)

options.final_time = t1;
delta = (t1-t0)/tp;
options.time_points = ceil(t1/delta);

range = [model.par_range(p,1),model.par_range(p,2);
         t0,t1];
gridPoints = [20,30];
grid = regularGrid(gridPoints,range);

basisFunc =  @(X)[1, X(1), X(2), X(1)^2, X(1)*X(2), X(2)^2];
%basisFunc =  @(X)[1, X(1), X(2)];

dBasisFunc = @(X)[0, 1, 0, 2*X(1), X(2),      0;
                  0, 0 ,1,      0, X(1), 2*X(2) ];

              
              
              
[ time,obs,obs1 ] = simulateModel( model, input, options );
index = time >= t0 & time <= t1;
[INPUT,OBS,OBS1] = mergeTraj(input,time(index),obs(:,:,index),obs1(:,:,:,index));


U = OBS(1:2,:)';
C = princomp(U);
dim = 5;
H0 = [1,0;
      0,1;
      1,1;
      C(:,1)';
      C(:,2)'];


lower = ones(dim,1);
upper = ones(dim,1);


for i=1:dim
    O = H0(i,1)*OBS(1,:) + H0(i,2)*OBS(2,:);
    O1 = H0(i,1)*OBS1(1,:,:) + H0(i,2)*OBS1(2,:,:);
    mm = abs(H0(i,1))*N0 + abs(H0(i,2))*N0;
    [l, u] = GPreach(INPUT,O,O1,kernel,grid,options,basisFunc,dBasisFunc);
    lower(i) = max(l,0*lower(i));
    upper(i) = min(u,mm*upper(i));
end


H = [ H0;
     -H0];
K=[upper;-lower];
P = polytope(H,K);
V = extreme(P);
ind = convhull(V(:,1),V(:,2));
V = V(ind,:);

end
