function grid = GPUCB_gridSample(n,domain)
%GPUCB_gridSample samples a grid of points in the input space
%   Samples n uniformly distributed points in the input space. The
%   input range and dimension is given in the params structure.

    if  domain.standardise 
        range = domain.range;
    else
        range = domain.trueRange;
    end
    %a |dimension|x n matrix (points are column vectors).
    grid = zeros(domain.dimension,n);
    for i = 1:n
            %unifrnd generates random numbers with upper and lower bounds
            %specified by the information in params.range.
            grid(:,i) = unifrnd(range(:,1),range(:,2));
    end
end

