function gridVals = randomGrid(n,range)
%propCheckGridSample samples a grid of points in the parameter space
%   Samples n uniformly distributed points in the parameter space. The
%   paraemter range and dimension is given in the params structure.

    dim = size(range,1);
    %a |dimension|x n matrix (points are column vectors).
    gridVals = zeros(dim,n);
    for i = 1:n 
        %unifrnd generates random numbers with upper and lower bounds
        %specified by the information in params.range.
        gridVals(:,i) = unifrnd(range(:,1),range(:,2));
    end
    gridVals = gridVals';
end

