function [ time,obs,obs1 ] = simulateModel( model, input, options )
%simulateModel - takes a model, integrates the equations

    k = size(input,1);
    d = size(input,2);
    time = linspace(0,options.final_time,options.time_points+1);
    
    obs = zeros(model.observables_dimension,k,options.time_points+1);
    obs1 = zeros(model.observables_dimension,d+1,k,options.time_points+1);
    
    for i=1:k 
        [x0,p] = model.reshapeInput(input(i,:),model);
        v0 = model.enlargeInitVars(x0,model);
        f = @(t,v)model.odefunc(v,p,t,model);
        [t,v] = ode45(f,time,v0);
        
        h=1;
        for j=1:size(v,1)
            if t(j)==time(h)
                obs(:,i,h) = model.observables(v(j,:),model);
                obs1(:,:,i,h) = model.sensitivity(v(j,:),p,model);
                h=h+1;
            end
        end
    end
    



  

    


end

